SystemOrganization addCategory: #MondrianGraphVizLayout!

MOLayout subclass: #MOGraphVizLayout
	instanceVariableNames: 'root extent ids layout useSplines'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MondrianGraphVizLayout'!

!MOGraphVizLayout commentStamp: 'jf 9/26/2008 17:46' prior: 0!
Calls the graphviz externally and let's it do the layout for us. OSProcess needs to be installed for it to work!

!MOGraphVizLayout class methodsFor: 'available layout types' stamp: 'tg 5/10/2010 17:45'!
circo
	^ self new circo; yourself! !

!MOGraphVizLayout class methodsFor: 'available layout types' stamp: 'tg 5/10/2010 17:45'!
dot
	^ self new dot; yourself! !

!MOGraphVizLayout class methodsFor: 'testing' stamp: 'Alexandre Bergel 7/26/2010 13:08'!
isAbstract
	^ false! !

!MOGraphVizLayout class methodsFor: 'available layout types' stamp: 'tg 5/10/2010 17:45'!
neato
	^ self new neato; yourself! !

!MOGraphVizLayout class methodsFor: 'available layout types' stamp: 'tg 5/10/2010 17:45'!
sfdp
	^ self new sfdp; yourself! !

!MOGraphVizLayout class methodsFor: 'available layout types' stamp: 'tg 5/10/2010 17:45'!
twopi
	^ self new twopi; yourself! !

!MOGraphVizLayout methodsFor: 'layout' stamp: 'Alexandre.Bergel 8/30/2009 11:41'!
applyLayoutToConnections: aCollection with: positions
	self flag: #TODO.
	"The code is brocken currently. Waiting for Bryce help
	Alexandre.Bergel 8/30/2009 11:40"

"	| controlPoints |
	
	aCollection do: [ :each |
		
		controlPoints := positions at: (((self ids at: each model key)) -> ((self ids at: each model value))).
		
		each setBounds: (MOBoundsWithPoints origin: (positions at: (self ids at: each model key))
										 corner: (positions at: (self ids at: each model value))).
										
		each bounds points: controlPoints
	]
"! !

!MOGraphVizLayout methodsFor: 'layout' stamp: 'tg 5/7/2010 16:04'!
applyLayoutToNodes: aCollection with: positions
	| minX minY minXId minYId nodePositions |
	nodePositions := positions associations select: [:assoc | assoc key isNumber].
	nodePositions isEmpty ifTrue: [^ self ].
	minX := nodePositions first value x.
	minY := nodePositions first value y.
	nodePositions do: [:assoc |
			assoc value x < minX ifTrue: [ minX := assoc value x ].
			assoc value y < minY ifTrue: [ minY := assoc value y ] ].
	aCollection do: [ :each |
		each translateTo: (positions at: (self ids at: each model)) - (minX @ minY).
"		each translateBy: ((each bounds width / 2) negated @ (each bounds height / 2) negated)
"	]! !

!MOGraphVizLayout methodsFor: 'layout' stamp: 'FabrizioPerin 5/28/2013 11:23'!
callGraphViz
	| source target process d |

	d := Delay forMilliseconds: 4000.
	
	source := (Smalltalk imageDirectory / 'mondrian_dot') fullName .
	target := (Smalltalk imageDirectory / 'mondrian_plain') fullName.	
	
	OSProcess isWindows
	ifTrue: [		
		#( 'C:\Program Files (x86)\Graphviz2.30\bin' 'C:\Program Files\Graphviz2.30\bin') 
			do: [ :each |
				(each asFileReference / self layout , 'exe' ) exists ifTrue: [
					process := OSProcess command: '"' , each , '\', self layout, '.exe' , '" -q -Tplain "' , source , '" -o "' , target , '"'.
					[process notNil and: [ (Smalltalk imageDirectory / 'mondrian_plain') exists "process isComplete" ] ] 
						whileFalse: [ d wait ].
					process complete.
					process closeStreams.
					^target ] ] ]
	ifFalse: [
		#( '.' '/bin' '/usr/bin' '/usr/local/bin' '/Applications/GraphViz.app/Contents/MacOS' ) 
			do: [ :each |
				(each asFileReference / self layout) exists ifTrue: [
					process := OSProcess waitForCommand: '"' , each , '/', self layout,'" -q -Tplain "' , source , '" -o "' , target , '"'.
					(process notNil and: [ Delay forMilliseconds: 50; isComplete ])
						ifTrue: [ ^ process ] ] ] ].
	
	self inform: 'Unable to run GraphViz. Please check that it is available through the command line.'.
	^ nil! !

!MOGraphVizLayout methodsFor: 'accessing-convenience' stamp: 'tg 5/10/2010 17:47'!
circo
	"circo - circular layout, after Six and Tollis 99, Kauffman and Wiese 02. This is suitable for certain diagrams of multiple cyclic structures such as certain telecommunications networks."
	^ self layout: 'circo'! !

!MOGraphVizLayout methodsFor: 'layout' stamp: 'lr 7/7/2010 08:36'!
createDotFileNodes: nodes connections: connections
	
	| dot |
	
	dot := FileStream fileNamed: 'mondrian_dot'.
	
	dot nextPutAll: 'digraph {'; cr;
		nextPutAll: 'splines= ', self useSplines asString, ';'; cr.
	
	self ids at: root ifPresent: [ :value |
		dot nextPutAll: 'root='; nextPutAll: value asString; nextPut: $;; cr. ].

	"write nodes to file, using the values of the identity hashes as the node name"	
	nodes do: [ :each |
		dot nextPutAll: (self ids at: each model) asString,
						' [ width = ', (each bounds width / self scaleFactor) asString,
						', height = ', (each bounds height / self scaleFactor) asString,
						', shape=box, fixedsize=true ];'; cr.
	].

	"write connections to file"
	connections do: [ :each |
		dot nextPutAll: (self ids at: each source model) asString.
		dot nextPutAll: ' -> '.
		dot nextPutAll: (self ids at: each target model) asString.
		dot nextPutAll: ' [ arrowhead=none ];'; cr.
	].
	
	dot nextPutAll: '}'.
	
	dot flush.
	dot close.! !

!MOGraphVizLayout methodsFor: 'layout' stamp: 'lr 10/4/2008 10:08'!
createIdMapping: nodes
	| idMap counter |
	
	idMap := IdentityDictionary new.

	counter := 1.
	nodes do: [ :each |
		idMap at: each model put: counter.
		counter := counter + 1.
	].

	^ idMap! !

!MOGraphVizLayout methodsFor: 'default values' stamp: 'tg 5/7/2010 21:49'!
defaultFromPositions
	^ #(center)! !

!MOGraphVizLayout methodsFor: 'default values' stamp: 'tg 5/7/2010 21:40'!
defaultToPositions
	^ #(center)! !

!MOGraphVizLayout methodsFor: 'layout' stamp: 'FabrizioPerin 5/28/2013 10:32'!
doExecute: anElement

	| positions |
	self ids: (self createIdMapping: anElement nodes).
		
	self removeTemporaryFiles.

	self createDotFileNodes: anElement nodes connections: anElement edges.
	
	self callGraphViz isNil ifTrue: [^ self].

	positions := self readLayoutFile.
	
	self applyLayoutToNodes: anElement nodes with: positions.
"	self applyLayoutToConnections: anElement edges with: positions."! !

!MOGraphVizLayout methodsFor: 'accessing-convenience' stamp: 'tg 5/10/2010 17:46'!
dot
	"dot - ``hierarchical'' or layered drawings of directed graphs. The layout algorithm aims edges in the same direction (top to bottom, or left to right) and then attempts to avoid edge crossings and reduce edge length."
	^ self layout: 'dot'! !

!MOGraphVizLayout methodsFor: 'accessing' stamp: 'jf 9/26/2008 17:10'!
extent
	^ extent! !

!MOGraphVizLayout methodsFor: 'accessing' stamp: 'jf 9/26/2008 17:10'!
extent: anObject
	extent := anObject! !

!MOGraphVizLayout methodsFor: 'accessing-convenience' stamp: 'tg 5/10/2010 17:47'!
fdp
	"fdp - ``spring model'' layouts similar to those of neato, but does this by reducing forces rather than working with energy. Fdp implements the Fruchterman-Reingold heuristic including a multigrid solver that handles larger graphs and clustered undirected graphs."
	^ self layout: 'fdp'! !

!MOGraphVizLayout methodsFor: 'accessing' stamp: 'jf 9/29/2008 15:46'!
ids
	^ ids! !

!MOGraphVizLayout methodsFor: 'accessing' stamp: 'jf 9/29/2008 15:46'!
ids: anObject
	ids := anObject! !

!MOGraphVizLayout methodsFor: 'initialize' stamp: 'tg 5/15/2009 15:40'!
initialize
	super initialize.

	self layout: 'fdp'.
	self useSplines: false.! !

!MOGraphVizLayout methodsFor: 'accessing' stamp: 'jf 10/12/2008 12:40'!
layout
	^ layout! !

!MOGraphVizLayout methodsFor: 'accessing' stamp: 'jf 10/12/2008 12:40'!
layout: anObject
	layout := anObject! !

!MOGraphVizLayout methodsFor: 'accessing-convenience' stamp: 'tg 5/10/2010 17:46'!
neato
	"neato - ``spring model'' layouts. Neato attempts to minimize a global energy function, which is equivalent to statistical multi-dimensional scaling. The solution is achieved using stress majorization, though the older Kamada-Kawai algorithm, using steepest descent, is also available. fdp implements the Fruchterman-Reingold heuristic including a multigrid solver that handles larger graphs and clustered undirected graphs."
	^ self layout: 'neato'! !

!MOGraphVizLayout methodsFor: 'layout' stamp: 'FabrizioPerin 5/28/2013 11:15'!
readLayoutFile

	| dot positions element controlPoints point separator |

	dot := FileStream fileNamed: 'mondrian_plain'.
	positions := Dictionary new.
	OSProcess isWindows
		ifTrue: [ separator := String crlf ]
		ifFalse: [ separator := String lf ].
	
	
	"graph header"
	element := (dot upToAll: separator ) subStrings: ' '.
	self extent: ((element at: 3) asNumber @ (element at: 4) asNumber) * self scaleFactor.
	
	"each line"
	element := (dot upToAll: separator) subStrings: ' '.
	
	[ (element at: 1) ~= 'stop' and: [ (element at: 1) ~= '' ] ]
		whileTrue: [
			"if node, save its position"
			(element first) = 'node' ifTrue: [
				positions at: (element at: 2) asNumber
						 put: (((element at: 3) asNumber) @ ((element at: 4) asNumber) * self scaleFactor)
			].

			"if edge, save all its control points"
			element first = 'edge' ifTrue: [
				controlPoints := OrderedCollection new.
				0 to: ((element at: 4) asNumber - 1) do: [ :index |
					point := ((element at: 5 + (index*2)) asNumber @ (element at: 6 + (index*2)) asNumber).
					controlPoints add: point * self scaleFactor .
				].
			
				positions at: ((element at: 2) asNumber -> (element at: 3) asNumber)
						 put: controlPoints.
			].
			
			element := (dot upToAll: separator) subStrings: ' '.
		].

	^ positions! !

!MOGraphVizLayout methodsFor: 'layout' stamp: 'AnneEtien 3/8/2013 10:38'!
removeTemporaryFiles
	(Smalltalk imageDirectory / 'mondrian_dot') ensureDeleted .
	(Smalltalk imageDirectory / 'mondrian_plain') ensureDeleted.! !

!MOGraphVizLayout methodsFor: 'accessing' stamp: 'lr 7/7/2010 08:33'!
root	
	^ root! !

!MOGraphVizLayout methodsFor: 'accessing' stamp: 'lr 7/7/2010 08:33'!
root: anObject
	"This specifies nodes to be used as the center of the layout and the root of the generated spanning tree. As a graph attribute, this gives the name of the node. As a node attribute (circo only), it specifies that the node should be used as a central node. In twopi, this will actually be the central node. In circo, the block containing the node will be central in the drawing of its connected component. If not defined, twopi will pick a most central node, and circo will pick a random node."
	
	root := anObject! !

!MOGraphVizLayout methodsFor: 'constants' stamp: 'jf 9/26/2008 15:35'!
scaleFactor
	^ 72.0
	! !

!MOGraphVizLayout methodsFor: 'accessing-convenience' stamp: 'tg 5/10/2010 17:47'!
sfdp
	"sfdp - multiscale version of fdp for the layout of large graphs."
	^ self layout: 'sfdp'! !

!MOGraphVizLayout methodsFor: 'accessing-convenience' stamp: 'tg 5/10/2010 17:48'!
twopi
	"twopi - radial layouts, after Graham Wills 97. The nodes are placed on concentric circles depending their distance from a given root node."
	^ self layout: 'twopi'! !

!MOGraphVizLayout methodsFor: 'accessing' stamp: 'jf 10/12/2008 12:40'!
useSplines
	^ useSplines! !

!MOGraphVizLayout methodsFor: 'accessing' stamp: 'jf 10/12/2008 12:40'!
useSplines: anObject
	useSplines := anObject! !

Object subclass: #MOAllLayouts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MondrianGraphVizLayout'!

!MOAllLayouts commentStamp: 'tg 5/10/2010 18:56' prior: 0!
MOAllLayouts exportView: [:view |
	view nodes: (1 to: 100).
	view shape arrowedLine.
	view edges: (1 to: 100) from: [:x | x // 10] to: #yourself.
	view nodes: (100 to: 200).
	view shape arrowedLine.
	view edges: (100 to: 200) from: [:x | (x // 10) + 100 ] to: #yourself.
]!

!MOAllLayouts class methodsFor: 'as yet unclassified' stamp: 'tg 5/10/2010 18:55'!
exportView: aBlock
	"aBlock should expect a view renderer as a parameter"

	| layouts |
	layouts := 
		{
		'mondrian-tree' -> MOTreeLayout new.
		'mondrian-dominance-tree' -> MODominanceTreeLayout new.
		'mondrian-circle' -> MOCircleLayout new.
		'mondrian-radial-tree' -> MORadialTreeLayout new.
		'graphviz-circo' -> MOGraphVizLayout circo.
		'graphviz-neato' -> MOGraphVizLayout neato.
		'graphviz-dot' -> MOGraphVizLayout dot.
		'graphviz-fdp' -> MOGraphVizLayout new.
		'graphviz-sfdp' -> MOGraphVizLayout sfdp.
		'graphviz-twopi' -> MOGraphVizLayout twopi.
		'mondrian-force-based-layout' -> MOForceBasedLayout new.
		'mondrian-spring-layout' -> MOSpringLayout new.
		}.
	layouts associationsDo: [:assoc | | view window |
		view := MOViewRenderer new.
		aBlock value: view.
		view layout: assoc value.
		window := view open.
		PNGReadWriter putForm: view canvas imageForm onFileNamed: (assoc key, '.png').
		window delete ]! !

!MOViewRenderer methodsFor: '*MondrianGraphVizLayout' stamp: 'tg 5/10/2010 14:20'!
graphvizLayout
	^ self layout: MOGraphVizLayout new! !

TestCase subclass: #MOGraphVizLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MondrianGraphVizLayout'!

!MOGraphVizLayoutTest methodsFor: 'tests' stamp: 'Nicolasanquetil 5/3/2013 15:11'!
testConstructors
	#(#neato #twopi #sfdp #dot #circo)
		do: [ :each | 
			self assert: (MOGraphVizLayout perform: each) layout equals: each asString.
			self assert: (MOGraphVizLayout new perform: each) layout equals: each asString ]! !

!MOGraphVizLayoutTest methodsFor: 'tests' stamp: 'Nicolasanquetil 5/3/2013 15:18'!
testDefaultConstructor
	self assert: MOGraphVizLayout new layout equals: 'fdp'! !

!MOGraphVizLayoutTest methodsFor: 'tests' stamp: 'Alexandre Bergel 7/26/2010 13:08'!
testIsAbstract
	self deny: MOGraphVizLayout isAbstract 
! !
